//////////
// item //
//////////
datablock ItemData(DualOrbLauncherItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	rotate = false;
	mass = 1;
	density = 0.2;

	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "";	//"MAS Dual Orb L.";
	iconName = "./Icon_DualOrbL";
	doColorShift = false;
	colorShiftColor = "0.100 0.500 0.250 1.000";

	 // Dynamic properties defined by the scripts
	image = RightOrbLauncherImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RightOrbLauncherImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   doColorShift = false;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = OrbLauncherProjectile;
   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;
//   minShotTime = 10;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   //casing = " ";`

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]		 = "Ready";
//	stateSound[0]					 = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;
//	stateSequence[1]				 = "root";

	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.2;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "charge";
//	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= OrbTrailEmitter;
	stateEmitterTime[2]				= 0.2;
	stateEmitterNode[2]				= "muzzleNode";
//	stateSound[2]					= radioWaveExplosionSound;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "FireDual";
	stateTimeoutValue[3]            = 0.3;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= OrbBounceExplosionEmitter;
	stateEmitterTime[3]				= 0.2;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= radioWaveExplosionSound;

	stateName[4]					= "FireDual";
	stateScript[4]                  = "onFireDual";
	stateWaitForTimeout[4]			= true;
	stateTransitionOnTimeout[4]     = "Reload";
	stateTimeoutValue[4]            = 0.1;
	stateAllowImageChange[4]        = false;

	stateName[5]					= "Reload";
	stateAllowImageChange[5]        = false;
	stateTimeoutValue[5]            = 0.3;
	stateWaitForTimeout[5]			= true;
	stateTransitionOnTriggerUp[5]     = "Ready";

//	stateName[5]                    = "StopFire";
//	stateTransitionOnTimeout[5]     = "Ready";
//	stateTimeoutValue[5]            = 0.2;
//	stateAllowImageChange[5]        = false;
//	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
//	stateScript[5]                  = "onStopFire";
};

datablock ShapeBaseImageData(LeftOrbLauncherImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   doColorShift = false;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = OrbLauncherProjectile;
   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;
//   minShotTime = 10;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   //casing = " ";`

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]		 = "Ready";
//	stateSound[0]					 = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;
//	stateSequence[1]				 = "root";

	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.2;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "charge";
//	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= OrbTrailEmitter;
	stateEmitterTime[2]				= 0.2;
	stateEmitterNode[2]				= "muzzleNode";
//	stateSound[2]					= radioWaveExplosionSound;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Reload";
	stateTimeoutValue[3]            = 0.45;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
//	stateSequence[3]                = "fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= OrbBounceExplosionEmitter;
	stateEmitterTime[3]				= 0.1;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= radioWaveExplosionSound;

	stateName[4]					= "Reload";
//	stateSequence[4]                = "Reload";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.01;
	stateWaitForTimeout[4]			= true;
//	stateTransitionOnTimeout[4]     = "Ready";
	stateTransitionOnTriggerUp[4]     = "Ready";

//	stateName[4]			= "Check";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

//	stateName[5]                    = "StopFire";
//	stateTransitionOnTimeout[5]     = "Ready";
//	stateTimeoutValue[5]            = 0.2;
//	stateAllowImageChange[5]        = false;
//	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
//	stateScript[5]                  = "onStopFire";
};

function RightOrbLauncherImage::onFireDual(%this,%obj,%slot)
{
	   %obj.setImageTrigger(1,1);
}

function RightOrbLauncherImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(LeftOrbLauncherImage, 1);
   //%obj.playThread(0, armreadyboth);
}
function RightOrbLauncherImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
}

function LeftOrbLauncherImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
//   %obj.playThread(1, armreadyboth);
}
function LeftOrbLauncherImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}
